<template>
  <div class="list row">
    <div class="col-md-6">
      <h4>Products List</h4>
      <ul class="list-group">
        <li
          class="list-group-item"
          :class="{ active: index == currentIndex }"
          v-for="(product, index) in products"
          :key="index"
          @click="setActiveProduct(product, index)"
        >
          {{ product.title }} - QTY: {{ product.quantity }}
        </li>
      </ul>
    </div>
    <div class="col-md-6">
      <div v-if="currentProduct">
        <product-details
          :product="currentProduct"
          @refreshList="refreshList"
        />
      </div>
      <div v-else>
        <br />
        <p>Click on a product to manage</p>
      </div>
    </div>
  </div>
</template>

<script>
import ProductService from "../services/ProductService";
import ProductDetails from "./Product";

export default {
  name: "product-list",
  components: { ProductDetails },
  data() {
    return {
      products: [],
      currentProduct: null,
      currentIndex: -1,
      loggedUser: null
    };
  },
  methods: {
    onDataChange(items) {
      let _products = [];

      items.forEach((item) => {
        let key = item.key;
        let data = item.val();
        _products.push({
          key: key,
          title: data.title,
          quantity: data.quantity,
          description: data.description,
        });
      });

      this.products = _products;
    },

    refreshList() {
      this.currentProducts = null;
      this.currentIndex = -1;
    },

    setActiveProduct(product, index) {
      this.currentProduct = product;
      this.currentIndex = index;
    },
  },
  mounted() {
    ProductService.getAll().on("value", this.onDataChange);
    const reload = localStorage.getItem("reload");
    if(reload){
      localStorage.removeItem("reload");
      window.location.reload();
    }
  },
  beforeDestroy() {
    ProductService.getAll().off("value", this.onDataChange);
  }
};
</script>

<style>
.list {
  text-align: left;
  max-width: 750px;
  margin: auto;
}
</style>
